package org.openxma.dsl.reference.dao.impl;

import org.openxma.dsl.platform.dao.*;
import org.openxma.dsl.platform.dao.impl.*;
import org.openxma.dsl.platform.service.Mapper;

import org.hibernate.Criteria;
import org.hibernate.Query;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Criterion;
import org.hibernate.criterion.Expression;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.jdbc.support.incrementer.DataFieldMaxValueIncrementer;
import org.springframework.stereotype.Repository;
import org.springframework.util.Assert;
import org.openxma.dsl.reference.dao.CertificateDao;
import org.openxma.dsl.reference.model.Certificate;
import org.openxma.dsl.reference.model.impl.CertificateImpl;
/**
 * @see CertificateDao
 */
@SuppressWarnings("unused")
public abstract class CertificateDaoGenImpl extends GenericDaoHibernateImpl<Certificate,String> implements CertificateDao {

    public CertificateDaoGenImpl() {
        super(CertificateImpl.class);
    }
    
    /**
     * @param context the context for the object creation
     * @return a transient instance of entity <code>Certificate</code> with an already assigned identifier.
     */
    public Certificate createEntity(Object context) {
        return create();
    }

    public Certificate create()
    {
        Certificate certificate = createEntityInstance();
        certificate.setOid(dataFieldMaxValueIncrementer.nextStringValue());
        return certificate;
    }
    
    protected Mapper getNamedQueryMapper(String queryName) {
		return new CertificateDaoQueryMapper();
	}
	
	protected class CertificateDaoQueryMapper extends NamedQueryMapper {
	
		@SuppressWarnings("unchecked")
		public <E> E mapOne(Object sourceObject, E targetObject, Object context) {
			return super.mapOne(sourceObject, targetObject);
		}
	}
}
