package org.openxma.dsl.reference.dao.impl;

import org.openxma.dsl.platform.dao.*;
import org.openxma.dsl.platform.dao.impl.*;
import org.openxma.dsl.platform.service.Mapper;

import org.hibernate.Criteria;
import org.hibernate.Query;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Criterion;
import org.hibernate.criterion.Expression;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.jdbc.support.incrementer.DataFieldMaxValueIncrementer;
import org.springframework.stereotype.Repository;
import org.springframework.util.Assert;
import org.openxma.dsl.reference.dao.RoleGroupDao;
import org.openxma.dsl.reference.model.RoleGroup;
import org.openxma.dsl.reference.model.impl.RoleGroupImpl;
/**
 * @see RoleGroupDao
 */
@SuppressWarnings("unused")
public abstract class RoleGroupDaoGenImpl extends GenericDaoHibernateImpl<RoleGroup,String> implements RoleGroupDao {

    public RoleGroupDaoGenImpl() {
        super(RoleGroupImpl.class);
    }
    
    /**
     * @param context the context for the object creation
     * @return a transient instance of entity <code>RoleGroup</code> with an already assigned identifier.
     */
    public RoleGroup createEntity(Object context) {
        return create();
    }

    public RoleGroup create()
    {
        RoleGroup roleGroup = createEntityInstance();
        roleGroup.setOid(dataFieldMaxValueIncrementer.nextStringValue());
        return roleGroup;
    }
    
    protected Mapper getNamedQueryMapper(String queryName) {
		return new RoleGroupDaoQueryMapper();
	}
	
	protected class RoleGroupDaoQueryMapper extends NamedQueryMapper {
	
		@SuppressWarnings("unchecked")
		public <E> E mapOne(Object sourceObject, E targetObject, Object context) {
			return super.mapOne(sourceObject, targetObject);
		}
	}
}
